From ef6ce87b713debbf82b98de05cdca1676290e6e5 Mon Sep 17 00:00:00 2001
From: Daniel Pimentel <d4n1@member.fsf.org>
Date: Sat, 10 Oct 2015 14:47:52 -0300
Subject: [PATCH 2/2] Translated

* gnu: licenses/gpl-faq.pt-br.po: updated to line 1035 (15%)
---
 licenses/gpl-faq.pt-br.po | 162 ++++++++++++++++++++++++++++++++++++++++++----
 1 file changed, 148 insertions(+), 14 deletions(-)

diff --git a/licenses/gpl-faq.pt-br.po b/licenses/gpl-faq.pt-br.po
index 4fcbf2c..8b2083d 100644
--- a/licenses/gpl-faq.pt-br.po
+++ b/licenses/gpl-faq.pt-br.po
@@ -40,7 +40,7 @@ msgstr ""
 
 #. type: Content of: <h3>
 msgid "Table of Contents"
-msgstr "Conteúdo"
+msgstr "Tabela de Conteúdos"
 
 #. type: Content of: <h4>
 msgid ""
@@ -119,9 +119,7 @@ msgstr ""
 
 #. type: Content of: <ul><li>
 msgid "<a href=\"#WhoHasThePower\">Who has the power to enforce the GPL?</a>"
-msgstr ""
-"<a href=\"#WhoHasThePower\">Quem tem o poder de assegurar que a GPL é "
-"obedecida?</a>"
+msgstr "<a href=\"#WhoHasThePower\">Quem tem o poder de aplicar GPL?</a>"
 
 #. type: Content of: <ul><li>
 msgid ""
@@ -316,6 +314,9 @@ msgid ""
 "require citation or acknowledgment in research papers which use the GPL-"
 "covered software or its output?</a>"
 msgstr ""
+"<a href=\"#RequireCitation\">A GPL me permite adicionar termos que requeria "
+"citação ou reconhecimento em trabalho de pesquisa que usa software GPL"
+"ou a sua produção?</a>"
 
 #. type: Content of: <ul><li>
 msgid ""
@@ -374,32 +375,41 @@ msgid ""
 "also like to make it clear that it can't be used for military and/or "
 "commercial uses. Can I do this?</a>"
 msgstr ""
+"<a href=\"#NoMilitary\">Eu gostaria de licenciar meu código sob a GPL, mas gostaria "
+"também de de deixar claro que isso não poderia ser usado para uso militares e/ou "
+"commercial. Eu posso fazer isso?</a>"
 
 #. type: Content of: <ul><li>
 msgid "<a href=\"#GPLHardware\">Can I use the GPL to license hardware?</a>"
-msgstr ""
+msgstr "<a href=\"#GPLHardware\">Eu posso usar a GPL para licenciar hardware?</a>"
 
 #. type: Content of: <ul><li>
 msgid ""
 "<a href=\"#Prelinking\">Does prelinking a GPLed binary to various libraries "
 "on the system, to optimize its performance, count as modification?</a>"
 msgstr ""
+"<a href=\"#Prelinking\">Previncular um binário GPL para várias bibliotecas "
+"no sistema, para otimizar o seu desempenho, conta como modificação?</a>"
 
 #. type: Content of: <ul><li>
 msgid "<a href=\"#LGPLJava\">How does the LGPL work with Java?</a>"
-msgstr ""
+msgstr "<a href=\"#LGPLJava\">Como a LGPL trabalha com Java?</a>"
 
 #. type: Content of: <ul><li>
 msgid ""
 "<a href=\"#WhyPropagateAndConvey\">Why did you invent the new terms &ldquo;"
 "propagate&rdquo; and &ldquo;convey&rdquo; in GPLv3?</a>"
 msgstr ""
+"<a href=\"#WhyPropagateAndConvey\">Porque você inventou os novos termos &ldquo;"
+"propagar&rdquo; e &ldquo;transmitir&rdquo; em GPLv3?</a>"
 
 #. type: Content of: <ul><li>
 msgid ""
 "<a href=\"#ConveyVsDistribute\">Is &ldquo;convey&rdquo; in GPLv3 the same "
 "thing as what GPLv2 means by &ldquo;distribute&rdquo;?</a>"
 msgstr ""
+"<a href=\"#ConveyVsDistribute\">&ldquo;Transmitido&rdquo; em GPLv3 é a mesma "
+"coisa que &ldquo;distribuído&rdquo; em GPLv2?</a>"
 
 #. type: Content of: <ul><li>
 msgid ""
@@ -407,6 +417,9 @@ msgid ""
 "covered program and run them, without distributing or conveying them to "
 "others, what does the license require of me?</a>"
 msgstr ""
+"<a href=\"#NoDistributionRequirements\">Se eu somente fizer cópias de um programa sob GPL-"
+"e executá-lo, sem distribuí-lo ou transmití-lo para os "
+"outros, o que a licença requer de mim?</a>"
 
 #. type: Content of: <ul><li>
 msgid ""
@@ -414,6 +427,9 @@ msgid ""
 "public&rdquo; as an example of propagation. What does this mean? Is making "
 "available a form of conveying?</a>"
 msgstr ""
+"<a href=\"#v3MakingAvailable\">GPLv3 tem &ldquo;disponibilizado para o "
+"público&rdquo; como um exemplo de progração. O que isso significa? Fazé-lo "
+"disponível é uma forma de transmití-lo?</a>"
 
 #. type: Content of: <ul><li>
 msgid ""
@@ -421,33 +437,43 @@ msgid ""
 "to the public are forms of propagation that are also conveying in GPLv3, "
 "what are some examples of propagation that do not constitute conveying?</a>"
 msgstr ""
+"<a href=\"#PropagationNotConveying\">Desde a distribuição e torná-lo disponível "
+"para o público como forma de progração que também são trnsmitido em GPLv3, "
+"o que são alguns exemplos de propagação que não constitui transmissão?</a>"
 
 #. type: Content of: <ul><li>
 msgid ""
 "<a href=\"#BitTorrent\">How does GPLv3 make BitTorrent distribution easier?</"
 "a>"
 msgstr ""
+"<a href=\"#BitTorrent\">Como a GPLv3 facilita a distribuição de BitTorrent?</"
+"a>"
 
 #. type: Content of: <ul><li>
 msgid ""
 "<a href=\"#Tivoization\">What is tivoization? How does GPLv3 prevent it?</a>"
 msgstr ""
+"<a href=\"#Tivoization\">O que é  tivoização? Como a GPLv3 previni isso?</a>"
 
 #. type: Content of: <ul><li>
 msgid "<a href=\"#DRMProhibited\">Does GPLv3 prohibit DRM?</a>"
-msgstr ""
+msgstr "<a href=\"#DRMProhibited\">A GPLv3 proibe DRM?</a>"
 
 #. type: Content of: <ul><li>
 msgid ""
 "<a href=\"#v3VotingMachine\">Does GPLv3 require that voters be able to "
 "modify the software running in a voting machine?</a>"
 msgstr ""
+"<a href=\"#v3VotingMachine\">A GPLv3 requer que eleitores seja capaz para "
+"modificar o software que está rodando en em uma máquina de votação?</a>"
 
 #. type: Content of: <ul><li>
 msgid ""
 "<a href=\"#v3PatentRetaliation\">Does GPLv3 have a &ldquo;patent retaliation "
 "clause&rdquo;?</a>"
 msgstr ""
+"<a href=\"#v3PatentRetaliation\">A GPLv3 tem uma &ldquo;claúsula de retaliação a "
+"patente&rdquo;?</a>"
 
 #. type: Content of: <ul><li>
 msgid ""
@@ -455,6 +481,9 @@ msgid ""
 "it says &ldquo;notwithstanding any other provision of this License&rdquo;?</"
 "a>"
 msgstr ""
+"<a href=\"#v3Notwithstanding\">Em GPLv3 e AGPLv3, o que significa quando "
+"diz &ldquo;não obstante alguma outra provisão dessa Licença&rdquo;?</"
+"a>"
 
 #. type: Content of: <ul><li>
 msgid ""
@@ -462,6 +491,9 @@ msgid ""
 "interacting with [the software] remotely through a computer network?&rdquo;</"
 "a>"
 msgstr ""
+"<a href=\"#AGPLv3InteractingRemotely\">Em AGPLv3, o que conta como &ldquo; "
+"interação com [o software] remotamente através de uma rede de computador?&rdquo;</"
+"a>"
 
 #. type: Content of: <ul><li>
 msgid ""
@@ -469,12 +501,17 @@ msgid ""
 "compare to the definition of &ldquo;Legal Entity&rdquo; in the Apache "
 "License 2.0?</a>"
 msgstr ""
+"<a href=\"#ApacheLegalEntity\">Como o conceito da GPLv3 de &ldquo;você&rdquo; "
+"comparar a definição de &ldquo;Entidade Legal&rdquo; na Licença Apache "
+"2.0?</a>"
 
 #. type: Content of: <ul><li>
 msgid ""
 "<a href=\"#v3TheProgram\">In GPLv3, what does &ldquo;the Program&rdquo; "
 "refer to? Is it every program ever released under GPLv3?</a>"
 msgstr ""
+"<a href=\"#v3TheProgram\">Em GPLv3, o que &ldquo;o Programa&rdquo; "
+"referece? Isso é todo programa lançado sob GPLv3?</a>"
 
 #. type: Content of: <ul><li>
 msgid ""
@@ -482,6 +519,9 @@ msgid ""
 "under AGPLv3, does it have to be able to provide source to the servers it "
 "interacts with?</a>"
 msgstr ""
+"<a href=\"#AGPLv3ServerAsUser\">Se algum software cliente de rede foi lançado "
+"sob AGPLv3, ele pode ser capaz de prover o código para os seus servidores "
+"interagir?</a>"
 
 #. type: Content of: <ul><li>
 msgid ""
@@ -489,15 +529,19 @@ msgid ""
 "the AGPL, how can I provide an offer of source to users interacting with "
 "that code?</a>"
 msgstr ""
-
+"<a href=\"#AGPLProxy\">Para o software que roda um servidor proxy licenciado sob "
+"a AGPL, como eu forneço uma oferta de origem para os usuários interagir com "
+"esse código?</a>"
+#todo:line
 #. type: Content of: <h4>
 msgid "Using GNU licenses for your programs"
-msgstr ""
+msgstr "Usando a licença GNU para seus programas"
 
 #. type: Content of: <ul><li>
 msgid ""
 "<a href=\"#v3HowToUpgrade\">How do I upgrade from (L)GPLv2 to (L)GPLv3?</a>"
 msgstr ""
+"<a href=\"#v3HowToUpgrade\">Como eu faço atualização de (L)GPLv2 para (L)GPLv3?</a>"
 
 #. type: Content of: <ul><li>
 msgid ""
@@ -512,19 +556,23 @@ msgid ""
 "<a href=\"#LicenseCopyOnly\">Is putting a copy of the GNU GPL in my "
 "repository enough to apply the GPL?</a>"
 msgstr ""
+"<a href=\"#LicenseCopyOnly\">Colocar uma cópia do GNU GPL em meu "
+"repositório é suficiente para aplicar a GPL?</a>"
 
 #. type: Content of: <ul><li>
 msgid ""
 "<a href=\"#NoticeInSourceFile\">Why should I put a license notice in each "
 "source file?</a>"
 msgstr ""
+"<a href=\"#NoticeInSourceFile\">Porque eu devo colocar uma nota de licença em cada "
+"arquivo de origem?</a>"
 
 #. type: Content of: <ul><li>
 msgid ""
 "<a href=\"#HowIGetCopyright\">How do I get a copyright on my program in "
 "order to release it under the GPL?</a>"
 msgstr ""
-"<a href=\"#HowIGetCopyright\">Como eu consigo o copyright do meu próprio "
+"<a href=\"#HowIGetCopyright\">Como eu consigo os direitos autorais do meu próprio "
 "programa de forma a distribui-lo sob a GPL?</a>"
 
 #. type: Content of: <ul><li>
@@ -533,7 +581,7 @@ msgid ""
 "into its own proprietary software product?</a>"
 msgstr ""
 "<a href=\"#WhatIfSchool\">E se minha escola quiser transformar meu programa "
-"em um produto de software proprietário seu?</a>"
+"em seu produto de software proprietário?</a>"
 
 #. type: Content of: <ul><li>
 msgid ""
@@ -560,12 +608,16 @@ msgid ""
 "<a href=\"#GPLUSGov\">Can the US Government release a program under the GNU "
 "GPL?</a>"
 msgstr ""
+"<a href=\"#GPLUSGov\">O governo Americano pode lançar um programa sob a GNU "
+"GPL?</a>"
 
 #. type: Content of: <ul><li>
 msgid ""
 "<a href=\"#GPLUSGovAdd\">Can the US Government release improvements to a GPL-"
 "covered program?</a>"
 msgstr ""
+"<a href=\"#GPLUSGovAdd\">O governo Americano pode lançar melhorias para um programa"
+"GPL?</a>"
 
 #. type: Content of: <ul><li>
 msgid ""
@@ -581,6 +633,9 @@ msgid ""
 "that a certain program can be used only under the latest version of the GNU "
 "GPL?</a>"
 msgstr ""
+"<a href=\"#OnlyLatestVersion\">É uma boa ideia usar a licença dizendo "
+"que um certo programa pode ser usado somente sob a versão do GNU "
+"GPL?</a>"
 
 #. type: Content of: <ul><li>
 msgid ""
@@ -595,19 +650,23 @@ msgstr ""
 
 #. type: Content of: <ul><li>
 msgid "<a href=\"#FontException\">How does the GPL apply to fonts?</a>"
-msgstr ""
+msgstr "<a href=\"#FontException\">Como aplicar a GPL para fontes?</a>"
 
 #. type: Content of: <ul><li>
 msgid ""
 "<a href=\"#WMS\">What license should I use for website maintenance system "
 "templates?</a>"
 msgstr ""
+"<a href=\"#WMS\">Qual licença eu devo usar para modelo de sistema de manutenção de "
+"website?</a>"
 
 #. type: Content of: <ul><li>
 msgid ""
 "<a href=\"#NonFreeTools\">Can I release a program under the GPL which I "
 "developed using non-free tools?</a>"
 msgstr ""
+"<a href=\"#NonFreeTools\">Eu posso lançar um programa sob a GPL que eu "
+"desenvolvi usando feramentas não-livres?</a>"
 
 #. type: Content of: <ul><li>
 msgid ""
@@ -615,6 +674,9 @@ msgid ""
 "assure its authenticity. Is it true that GPLv3 forces me to release my "
 "private signing keys?</a>"
 msgstr ""
+"<a href=\"#GiveUpKeys\">Eu uso uma chave pública criptográfica para assinar meu código para "
+"assegurar sua autenticidade. É verdade que a GPLv3 me força disponibilizar minhas "
+"chaves privadas de assinatura?</a>"
 
 #. type: Content of: <ul><li>
 msgid ""
@@ -622,6 +684,9 @@ msgid ""
 "disclaimers in GPLv3 seem specific to U.S. law. Can I add my own disclaimers "
 "to my own code?</a>"
 msgstr ""
+"<a href=\"#v3InternationalDisclaimers\">A garantia e resposibilidade "
+"dos avisos legais em GPLv3 visto especificamente para a lei dos Estados Unidos. Eu posso adicionar meus próprios avisos legais "
+"para meu próprio código?</a>"
 
 #. type: Content of: <ul><li>
 msgid ""
@@ -629,16 +694,21 @@ msgid ""
 "interfaces that are non-visual in nature. How can I comply with the "
 "Appropriate Legal Notices requirement in GPLv3?</a>"
 msgstr ""
+"<a href=\"#NonvisualLegalNotices\">Meu programa tem uma interface interativa "
+"com o usuário que são natualmente não visual. Como eu concordo com os "
+"Avisos de Apropriação Legal requerido em GPLv3?</a>"
 
 #. type: Content of: <h4>
 msgid "Distribution of programs released under the GNU licenses"
-msgstr ""
+msgstr "Distribuição de programas lançadas sob as licenças GNU"
 
 #. type: Content of: <ul><li>
 msgid ""
 "<a href=\"#ModifiedJustBinary\">Can I release a modified version of a GPL-"
 "covered program in binary form only?</a>"
 msgstr ""
+"<a href=\"#ModifiedJustBinary\">Eu posso lançar uma versão modificada de um programa GPL"
+"em forma binária somente?</a>"
 
 #. type: Content of: <ul><li>
 msgid ""
@@ -646,6 +716,9 @@ msgid ""
 "If I distribute copies, do I have to get the source and distribute that too?"
 "</a>"
 msgstr ""
+"<a href=\"#UnchangedJustBinary\">Eu baixei somente o binário da rede.  "
+"Se eu distribuir cópias, eu tenho que pegar os fontes e distribui-lo também?"
+"</a>"
 
 #. type: Content of: <ul><li>
 msgid ""
@@ -653,6 +726,9 @@ msgid ""
 "via physical media without accompanying sources.  Can I provide source code "
 "by FTP instead of by mail order?</a>"
 msgstr ""
+"<a href=\"#DistributeWithSourceOnInternet\">Eu quero distribuir binários "
+"via mídia física sem os fontes. Eu forneço o código fonte "
+"por FTP ao invés de email?</a>"
 
 #. type: Content of: <ul><li>
 msgid ""
@@ -660,6 +736,9 @@ msgid ""
 "binary with an offer to supply source, and made a copy for me.  Can I use "
 "the offer to obtain the source?</a>"
 msgstr ""
+"<a href=\"#RedistributedBinariesGetSource\">Meu amigo pegou um binário sob GPL "
+"com uma oferta para fornecer o fonte, e fez uma cópia para mim.  Eu posso usar "
+"a oferta para obter o fonte?</a>"
 
 #. type: Content of: <ul><li>
 msgid ""
@@ -715,6 +794,9 @@ msgid ""
 "to provide source code that can be built to match the exact hash of the "
 "binary I am distributing?</a>"
 msgstr ""
+"<a href=\"#MustSourceBuildToMatchExactHashOfBinary\">A GPL exigi-me "
+"prover o código fonte que possa ser construído para combinar o hash exato do "
+"binário que eu estou distribuindo?</a>"
 
 #. type: Content of: <ul><li>
 msgid ""
@@ -722,6 +804,9 @@ msgid ""
 "says that you can distribute modified versions of it under the GPL but you "
 "can't distribute the original itself under the GPL?</a>"
 msgstr ""
+"<a href=\"#ReleaseNotOriginal\">Eu posso lançar um programa com uma licença que "
+"diz que você pode distribuir versões modificadas dela sob a GPL mas você "
+"não pode distribuir a mesma versão original sob a GPL?</a>"
 
 #. type: Content of: <ul><li>
 msgid ""
@@ -739,12 +824,17 @@ msgid ""
 "GPL'ed program on a web site.  Does the GPL say they must release their "
 "modified sources?</a>"
 msgstr ""
+"<a href=\"#UnreleasedMods\">Uma empresa está rodando uma versão modificada de um "
+"programa GPL em um web site.  A GPL diz que eles devem lançar os "
+"fontes modificados?</a>"
 
 #. type: Content of: <ul><li>
 msgid ""
 "<a href=\"#InternalDistribution\">Is use within one organization or company "
 "&ldquo;distribution&rdquo;?</a>"
 msgstr ""
+"<a href=\"#InternalDistribution\">Uso dentro de uma organização ou empresa e "
+"&ldquo;distribuição&rdquo;?</a>"
 
 #. type: Content of: <ul><li>
 msgid ""
@@ -752,12 +842,17 @@ msgid ""
 "covered program, does the GPL give him the right to redistribute that "
 "version?</a>"
 msgstr ""
+"<a href=\"#StolenCopy\">Se alguém roubar um CD contendo uma versão modificada de um programa GPL,"
+"a GPL dar a ele o direito de redistribuir essa "
+"versão?</a>"
 
 #. type: Content of: <ul><li>
 msgid ""
 "<a href=\"#TradeSecretRelease\">What if a company distributes a copy as a "
 "trade secret?</a>"
 msgstr ""
+"<a href=\"#TradeSecretRelease\">E se uma empresa distribuir uma cópia como um "
+"comércio secreto?</a>"
 
 #. type: Content of: <ul><li>
 msgid ""
@@ -772,6 +867,8 @@ msgid ""
 "<a href=\"#DistributeSubsidiary\">Does moving a copy to a majority-owned, "
 "and controlled, subsidiary constitute distribution?</a>"
 msgstr ""
+"<a href=\"#DistributeSubsidiary\">Movendo uma cópia para uma participada maioritariamente, "
+"e controlado, subsidiário constitue distribuição?</a>"
 
 #. type: Content of: <ul><li>
 msgid ""
@@ -779,6 +876,9 @@ msgid ""
 "agree to the GPL? If I get some software under the GPL, do I have to agree "
 "to anything?</a>"
 msgstr ""
+"<a href=\"#ClickThrough\">Instaladores de software pode perguntar para que as pessoas cliquem para "
+"concordar com GPL? Se eu pegar algum software sob GPL, eu tenho que concordar "
+"com qualquer coisa?</a>"
 
 #. type: Content of: <ul><li>
 msgid ""
@@ -786,6 +886,9 @@ msgid ""
 "some sort of installation software.  Does that installer need to have a GPL-"
 "compatible license?</a>"
 msgstr ""
+"<a href=\"#GPLCompatInstaller\">Eu gostaria de empacotar um software GPL com "
+"algum tipo de software de instalação.  O instalador necessita ter uma licença compatível"
+" com a GPL?</a>"
 
 #. type: Content of: <ul><li>
 msgid ""
@@ -794,6 +897,10 @@ msgid ""
 "US, or that I intend to distribute the software in compliance with relevant "
 "export control laws?</a>"
 msgstr ""
+"<a href=\"#ExportWarranties\">Um distribuidor viola a GPL se ele "
+"requerer-me &ldquo;representar e garantir&rdquo; que eu localizado nos "
+"Estados Unidos, ou que eu tenha intenção de distribuir o software em conformidade com a relevância "
+"as leis de controle de exportação?</a>"
 
 #. type: Content of: <ul><li>
 msgid ""
@@ -802,6 +909,10 @@ msgid ""
 "4 and 5&rdquo; provided I also meet the conditions of section 6. What does "
 "that mean?</a>"
 msgstr ""
+"<a href=\"#v3Under4and5\">O início da seção 6 da GPLv3 diz que eu posso "
+"transmitir um trabalho coberto em forma de código objeto provido &ldquo;sob os termos das seções "
+"4 e 5&rdquo;, eu também conheço as condições da seção 6. O que "
+"isso significa?</a>"
 
 #. type: Content of: <ul><li>
 msgid ""
@@ -812,12 +923,20 @@ msgid ""
 "my contributions) under GPLv3, does that mean I've automatically granted "
 "GPLv3's explicit patent license to that user?</a>"
 msgstr ""
+"<a href=\"#v2OrLaterPatentLicense\">Minha empresa possui muitas patentes. Durante "
+"anos nós temos contribuído com código para projetos sob &ldquo;GPL versão 2 ou "
+"qualquer versão posterior&rdquo;, e o projeto tem-se distribuido sob "
+"os mesmos termos. Se um usuário decidir levar o código do projeto (incorporando "
+"minhas contribuições) sob GPLv3, isso significa que eu terei automaticamente concedido "
+"uma licença de patente explícita da GPLv3 para esse usuário?</a>"
 
 #. type: Content of: <ul><li>
 msgid ""
 "<a href=\"#v3ConditionalWarranty\">If I distribute a GPLv3-covered program, "
 "can I provide a warranty that is voided if the user modifies the program?</a>"
 msgstr ""
+"<a href=\"#v3ConditionalWarranty\">Se eu distribuir um programa sob GPLv3, "
+"eu posso prover uma garantia que está anulada se o usuário modificar o programa?</a>"
 
 #. type: Content of: <ul><li>
 msgid ""
@@ -825,6 +944,9 @@ msgid ""
 "to a coworker at my company, have I &ldquo;conveyed&rdquo; the copy to him?</"
 "a>"
 msgstr ""
+"<a href=\"#v3CoworkerConveying\">Se eu dar uma cópia de um programa sob GPL "
+"para um colega de trabalho na minha empresa, eu tenho &ldquo;tranportado&rdquo; a cópia para ele?</"
+"a>"
 
 #. type: Content of: <ul><li>
 msgid ""
@@ -832,6 +954,9 @@ msgid ""
 "FTP server and sources by way of a link to a source code repository in a "
 "version control system, like CVS or Subversion?</a>"
 msgstr ""
+"<a href=\"#SourceInCVS\">Eu estou em cumprimento com a GPLv3 se eu oferecer binários em um "
+"servidor FTP e os fontes por meio de um link para o repositório com o código fonte em um "
+"sistema de controle de versão, como CVS ou Subversion?</a>"
 
 #. type: Content of: <ul><li>
 msgid ""
@@ -839,12 +964,17 @@ msgid ""
 "software in a User Product use remote attestation to prevent a user from "
 "modifying that software?</a>"
 msgstr ""
+"<a href=\"#RemoteAttestation\">Alguém pode transmitir um software sob GPLv3 "
+"em um produto de uso remoto com a atestação para previnir o usuário de "
+"modificar esse software?</a>"
 
 #. type: Content of: <ul><li>
 msgid ""
 "<a href=\"#RulesProtocols\">What does &ldquo;rules and protocols for "
 "communication across the network&rdquo; mean in GPLv3?</a>"
 msgstr ""
+"<a href=\"#RulesProtocols\">Que &ldquo;regras e protocolos para "
+"comunicação através da rede&rdquo; significa em GPLv3?</a>"
 
 #. type: Content of: <ul><li>
 msgid ""
@@ -853,11 +983,15 @@ msgid ""
 "service&rdquo; for the product. What kind of &ldquo;support service&rdquo; "
 "do you mean?</a>"
 msgstr ""
+"<a href=\"#SupportService\">Distribuidores que prover Informações de Instalação "
+" sob GPLv3 não são requeridos para prover &ldquo;serviço de "
+"apoio&rdquo; para o produto. Que tipo de &ldquo;serviço de apoio&rdquo; "
+"você quer dizer?</a>"
 
 #. type: Content of: <h4>
 msgid ""
 "Using programs released under the GNU licenses when writing other programs"
-msgstr ""
+msgstr "Usando programas lançados sob as licenças GNU, ao escrever outros programas"
 
 #. type: Content of: <ul><li>
 msgid ""
-- 
2.5.0